
Define  OSC     48
'CONFIGURATIONS ARE IN /PBP/18F2550.INC , YOU MIGHT WANT TO EDIT THEM

'ADC
DEFINE ADC_BITS 10 		' Set number of bits in result
DEFINE ADC_CLOCK 6		' Set clock source  Fosc/64  => TAD => 1.34uS
DEFINE ADC_SAMPLEUS 50 	' Set sampling time in uS


TRISA.0 = 1
TRISA.1 = 1

ADCON1 = %00001101 ' sets AN0,AN1 to analog mode 

ADCON2 = %10101110 ' 
	'bit 0-2: ADCS ,OVERWRITTEN BY ADC_CLOCK,  110: Fosc/64  => TAD => 1.34uS
	'bit 3-5: Aquisition time: 101: 12 TAD =>  16uS
	'bit 6: not used
	'bit 7: Right justify for 10-bit 
	

x	VAR	WORD 
y	VAR Word



INTCON2.7=0  'RBPU =0 , TURN ON PORTB PULL-UPS

bt1			VAR PORTB.0
				TRISB.0 = 1
bt2			VAR PORTB.1
				TRISB.1 = 1
bt3			VAR PORTB.2
				TRISB.2 = 1
bt4			VAR PORTB.3
				TRISB.3 = 1

pinTx       VAR PORTC.6     'used for Debug
                TRISC.6 = 0	


'USB
buffer	Var	Byte[3]
USBInit

main:
	ADCIN 0,x	'read AN0
	ADCIN 1,y	'read AN1
	
    'x,y experimental measurments: ~512 @center / ~365 @ -90deg / -655 @ +90deg
    
    x = (x >> 2) << 2  ' clear last 2 bits
    y = (y >> 2) << 2  ' clear last 2 bits
    
    
    'convert x,y from range [384..512..639] to [0..128..255] with edge clipping
    x = ((x MAX 384) MIN 639 ) - 384
    y = ((y MAX 384) MIN 639 ) - 384
		
	buffer[0] = y	'gamepad's x-axis is accelerometer's y axis
	buffer[1] = x	'gamepad's y-axis is accelerometer's x axis
	buffer[2] = PORTB ^ %00001111 &	%00001111 'separate and reverse first 4 bits
   
    
    
	USBService	' Must service USB regularly
	USBOut 1, buffer, 3, main  ' Send buffer to endpoint 1

GOTO main	' Do it forever
